% flatoms( NestedAtoms, Atom ) :-
% iso.

:- lib(lists). 	% reverse/2, append/3.
:- lib( number_codes/2 ).

flatoms( Atoms, Atom ) :-
	flatoms( Atoms, [], Mota ),
	reverse( Mota, AtomCs ),
	atom_codes( Atom, AtomCs ).

flatoms( Atoms, Acc, Codes ) :-
	( Atoms = [] -> 
		Acc = Codes 
		;
		( Atoms = [H|T] -> 
			flatoms( H, Acc, Acc1 ),
			flatoms( T, Acc1, Codes )
			;
			( number(Atoms) ->
				number_codes( Atoms, AtomCodes )
				;
				atom_codes( Atoms, AtomCodes )
			),
			reverse( AtomCodes, Addition ),
			append( Addition, Acc, Codes )
		)
	).
