%% postfix_atom( ?Psf, ?Atom ).
%
% Version suitable for apply calls, such as in include/3.
%
% ==
% ?-  directory_files( '.', All ), 
%     include( postfix_atom('_pc30.csv'), All, Pc30s ).
%     All = [...]
%     Pc30s = ['abc_pc30.csv,...].
%    
% ==
%@author Nicos Angelopoulos
%@version 0.1 2014/02/09.
%
postfix_atom( Psf, Atom ) :-
     atom_concat( _, Psf, Atom ).
	
%% postfix_atom( ?Psf, ?Atom, -Prefix ).
%
% Prefix is a prefix of Atom with Psf being the remainder of Atom.
% This is a resuffle of atom_concat/3 arguments, with this version being suitable for apply calls, such as in map_succ_list/3.
%
% ==
% ?-  directory_files( '.', All ), 
%     map_succ_list( postfix_atom('xyz.csv'), All, XYZs ).
%    
% ?- maplist( postfix_atom('_ic60'), Full, [abc,edf] ).
% Full = [abc_ic60, edf_ic60].
% 
% ==
%@author Nicos Angelopoulos
%@version 0.1 2014/01/09.
%
postfix_atom( Psf, Atom, Pfx ) :-
     atom_concat( Pfx, Psf, Atom ).
