read_nth_unifying_term( File, ArgNth, Match, Term ) :-
	open( File, read, In ),
	Str = ArgNth/File,
     read_nth_unifying_term_from_stream( In, ArgNth, Match, Str, Term ),
     close( In ).

read_nth_unifying_term_from_stream( In, ArgNth, Match, Str, Term ) :-
	read( In, First ),
	( \+ First = Match ->
		Nth is ArgNth
		;
		Nth is ArgNth - 1
	),
	read_nth_unifying_term_from_stream( First, Nth, In, Match, Str, Term ).

read_nth_unifying_term_from_stream( end_of_file, Nth, _In, _Match, Str, _Term ) :-
	!,
	Str = Nth/File,
	throw( not_enough_terms_present_in_file(Nth,File) ).
read_nth_unifying_term_from_stream( Read, Nth, _In, Match, _Str, Term ) :-
	Nth < 1, \+ \+ Read = Match,
	!,
	Term = Read.
read_nth_unifying_term_from_stream( _Read, N, In, Match, Str, Term ) :-
	read( In, NxRead ),
	( \+ (NxRead = Match) ->
		NxN is N 
		;
		NxN is N - 1
	),
	read_nth_unifying_term_from_stream( NxRead, NxN, In, Match, Str, Term ).
